PF-build.sh 36 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_15
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have seperated build enviroments depening on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Audrino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. #### Start check if OSTYPE is supported
  124. OS_FOUND=$( command -v uname)
  125. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  126. linux*)
  127. TARGET_OS="linux"
  128. ;;
  129. msys*|cygwin*|mingw*)
  130. # or possible 'bash on windows'
  131. TARGET_OS='windows'
  132. ;;
  133. nt|win*)
  134. TARGET_OS='windows'
  135. ;;
  136. *)
  137. TARGET_OS='unknown'
  138. ;;
  139. esac
  140. # Windows
  141. if [ $TARGET_OS == "windows" ]; then
  142. if [ $(uname -m) == "x86_64" ]; then
  143. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  144. Processor="64"
  145. elif [ $(uname -m) == "i386" ]; then
  146. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  147. Processor="32"
  148. else
  149. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  150. echo "Please refer to the notes of build.sh$(tput sgr0)"
  151. exit 1
  152. fi
  153. # Linux
  154. elif [ $TARGET_OS == "linux" ]; then
  155. if [ $(uname -m) == "x86_64" ]; then
  156. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  157. Processor="64"
  158. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  159. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  160. Processor="32"
  161. else
  162. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  163. echo "Please refer to the notes of build.sh$(tput sgr0)"
  164. exit 1
  165. fi
  166. else
  167. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  168. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  169. echo "Read the notes of build.sh$(tput sgr0)"
  170. exit 1
  171. fi
  172. sleep 2
  173. #### End check if OSTYPE is supported
  174. #### Prepare bash environment and check if wget, zip and other needed things are available
  175. # Check wget
  176. if ! type wget > /dev/null; then
  177. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  178. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  179. exit 2
  180. fi
  181. # Check for zip
  182. if ! type zip > /dev/null; then
  183. if [ $TARGET_OS == "windows" ]; then
  184. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  185. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  186. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  187. echo "Run git Bash under Administrator privilege and"
  188. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  189. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  190. exit 3
  191. elif [ $TARGET_OS == "linux" ]; then
  192. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  193. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  194. exit 3
  195. fi
  196. fi
  197. # Check python ... needed during language build
  198. if ! type python > /dev/null; then
  199. if [ $TARGET_OS == "windows" ]; then
  200. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  201. exit 4
  202. elif [ $TARGET_OS == "linux" ]; then
  203. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  204. echo "As Python 2.x will not be maintained from 2020 please,"
  205. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  206. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  207. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  208. exit 4
  209. fi
  210. fi
  211. #### End prepare bash / Linux environment
  212. #### Set build environment
  213. ARDUINO_ENV="1.8.5"
  214. BUILD_ENV="1.0.6"
  215. BOARD="prusa_einsy_rambo"
  216. BOARD_PACKAGE_NAME="PrusaResearch"
  217. BOARD_VERSION="1.0.3"
  218. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  219. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  220. BOARD_FILENAME="prusa3dboards"
  221. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  222. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  223. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  224. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  225. LIB="PrusaLibrary"
  226. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  227. # List few useful data
  228. echo
  229. echo "Script path :" $SCRIPT_PATH
  230. echo "OS :" $OS
  231. echo "OS type :" $TARGET_OS
  232. echo ""
  233. echo "Ardunio IDE :" $ARDUINO_ENV
  234. echo "Build env :" $BUILD_ENV
  235. echo "Board :" $BOARD
  236. echo "Package name:" $BOARD_PACKAGE_NAME
  237. echo "Board v. :" $BOARD_VERSION
  238. echo "Specific Lib:" $LIB
  239. echo ""
  240. #### Start prepare building environment
  241. #Check if build exists and creates it if not
  242. if [ ! -d "../PF-build-dl" ]; then
  243. mkdir ../PF-build-dl || exit 5
  244. fi
  245. cd ../PF-build-dl || exit 6
  246. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  247. # Check if PF-build-env-<version> exists and downloads + creates it if not
  248. # The build environment is based on the supported Arduino IDE portable version with some changes
  249. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  250. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  251. mkdir ../PF-build-env-$BUILD_ENV
  252. sleep 5
  253. fi
  254. # Download and extract supported Arduino IDE depending on OS
  255. # Windows
  256. if [ $TARGET_OS == "windows" ]; then
  257. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  258. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  259. sleep 2
  260. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  261. echo "$(tput sgr 0)"
  262. fi
  263. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  264. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  265. sleep 2
  266. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  267. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  268. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  269. echo "$(tput sgr0)"
  270. fi
  271. fi
  272. # Linux
  273. if [ $TARGET_OS == "linux" ]; then
  274. # 32 or 64 bit version
  275. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  276. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  277. sleep 2
  278. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  279. echo "$(tput sgr 0)"
  280. fi
  281. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  282. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  283. sleep 2
  284. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  285. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  286. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  287. echo "$(tput sgr0)"
  288. fi
  289. fi
  290. # Make Arduino IDE portable
  291. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  292. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  293. fi
  294. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  295. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  296. fi
  297. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  298. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  299. fi
  300. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  301. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  302. fi
  303. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  304. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  305. fi
  306. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  307. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  308. fi
  309. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  310. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  311. fi
  312. # Change Arduino IDE preferences
  313. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  314. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  315. sleep 2
  316. echo "update.check"
  317. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  318. echo "board"
  319. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  320. echo "editor.linenumbers"
  321. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  322. echo "boardsmanager.additional.urls"
  323. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  324. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  325. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  326. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  327. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  328. echo "$(tput sgr0)"
  329. fi
  330. # Download and extract Prusa Firmware related parts
  331. # Download and extract PrusaResearchRambo board
  332. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  333. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  334. sleep 2
  335. wget $BOARD_FILE_URL || exit 9
  336. fi
  337. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  338. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  339. sleep 2
  340. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  341. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  342. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  343. fi
  344. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  345. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  346. fi
  347. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  348. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  349. fi
  350. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  351. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  352. fi
  353. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  354. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  355. echo "$(tput sgr 0)"
  356. fi
  357. # Download and extract Prusa Firmware specific library files
  358. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  359. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  360. sleep 2
  361. wget $PF_BUILD_FILE_URL || exit 11
  362. echo "$(tput sgr 0)"
  363. fi
  364. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  365. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  366. sleep 2
  367. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  368. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  369. echo "$(tput sgr0)"
  370. fi
  371. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  372. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  373. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  374. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  375. sleep 2
  376. fi
  377. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  378. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  379. sleep 2
  380. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  381. sleep 2
  382. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  383. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  384. echo "$(tput sgr0)"
  385. fi
  386. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  387. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  388. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  389. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  390. sleep 2
  391. echo "$(tput sgr0)"
  392. exit 13
  393. fi
  394. #### End prepare building
  395. #### Start
  396. cd $SCRIPT_PATH
  397. # First argument defines which variant of the Prusa Firmware will be compiled
  398. if [ -z "$1" ] ; then
  399. # Select which variant of the Prusa Firmware will be compiled, like
  400. PS3="Select a variant: "
  401. while IFS= read -r -d $'\0' f; do
  402. options[i++]="$f"
  403. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  404. select opt in "${options[@]}" "All" "Quit"; do
  405. case $opt in
  406. *.h)
  407. VARIANT=$(basename "$opt" ".h")
  408. VARIANTS[i++]="$opt"
  409. break
  410. ;;
  411. "All")
  412. VARIANT="All"
  413. VARIANTS=${options[*]}
  414. break
  415. ;;
  416. "Quit")
  417. echo "You chose to stop"
  418. exit
  419. ;;
  420. *)
  421. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  422. ;;
  423. esac
  424. done
  425. else
  426. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  427. VARIANTS=$1
  428. else
  429. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  430. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  431. echo "$(tput sgr0)"
  432. exit 21
  433. fi
  434. fi
  435. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  436. #Check default language mode
  437. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  438. if [ -z "$2" ] ; then
  439. PS3="Select a language: "
  440. echo
  441. echo "Which lang-build do you want?"
  442. select yn in "Multi languages" "English only"; do
  443. case $yn in
  444. "Multi languages")
  445. LANGUAGES="ALL"
  446. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  447. break
  448. ;;
  449. "English only")
  450. LANGUAGES="EN_ONLY"
  451. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  452. break
  453. ;;
  454. *)
  455. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  456. ;;
  457. esac
  458. done
  459. else
  460. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  461. LANGUAGES=$2
  462. else
  463. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  464. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  465. exit 22
  466. fi
  467. fi
  468. #Check if DEV_STATUS is selected via argument 3
  469. if [ ! -z "$3" ] ; then
  470. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" ]] ; then
  471. DEV_STATUS_SELECTED=$3
  472. else
  473. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  474. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL' or 'DEBUG'$(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  475. exit 23
  476. fi
  477. fi
  478. #Set BUILD_ENV_PATH
  479. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 24
  480. BUILD_ENV_PATH="$( pwd -P )"
  481. cd ../..
  482. #Checkif BUILD_PATH exists and if not creates it
  483. if [ ! -d "Prusa-Firmware-build" ]; then
  484. mkdir Prusa-Firmware-build || exit 25
  485. fi
  486. #Set the BUILD_PATH for Arduino IDE
  487. cd Prusa-Firmware-build || exit 26
  488. BUILD_PATH="$( pwd -P )"
  489. for v in ${VARIANTS[*]}
  490. do
  491. VARIANT=$(basename "$v" ".h")
  492. # Find firmware version in Configuration.h file and use it to generate the hex filename
  493. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  494. # Find build version in Configuration.h file and use it to generate the hex filename
  495. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  496. # Check if the motherboard is an EINSY and if so only one hex file will generated
  497. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  498. # Check development status
  499. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  500. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  501. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  502. DEV_STATUS="RC"
  503. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  504. DEV_STATUS="ALPHA"
  505. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  506. DEV_STATUS="BETA"
  507. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  508. DEV_STATUS="DEVEL"
  509. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  510. DEV_STATUS="DEBUG"
  511. else
  512. DEV_STATUS="UNKNOWN"
  513. echo
  514. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  515. PS3="Select YES only if source code is tested and trusted: "
  516. select yn in "Yes" "No"; do
  517. case $yn in
  518. Yes)
  519. DEV_STATUS="GOLD"
  520. DEV_STATUS_SELECTED="GOLD"
  521. break
  522. ;;
  523. No)
  524. DEV_STATUS="UNKNOWN"
  525. DEV_STATUS_SELECTED="UNKNOWN"
  526. break
  527. ;;
  528. *)
  529. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  530. ;;
  531. esac
  532. done
  533. fi
  534. else
  535. DEV_STATUS=$DEV_STATUS_SELECTED
  536. fi
  537. #Prepare hex files folders
  538. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  539. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  540. fi
  541. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  542. #Check if exactly the same hexfile already exists
  543. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  544. echo ""
  545. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  546. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  547. read -t 10 -p "Press Enter to continue..."
  548. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  549. echo ""
  550. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  551. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  552. read -t 10 -p "Press Enter to continue..."
  553. fi
  554. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  555. echo ""
  556. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  557. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  558. read -t 10 -p "Press Enter to continue..."
  559. fi
  560. #List some useful data
  561. echo "$(tput setaf 2)$(tput setab 7) "
  562. echo "Variant :" $VARIANT
  563. echo "Firmware :" $FW
  564. echo "Build # :" $BUILD
  565. echo "Dev Check :" $DEV_CHECK
  566. echo "DEV Status :" $DEV_STATUS
  567. echo "Motherboard:" $MOTHERBOARD
  568. echo "Languages :" $LANGUAGES
  569. echo "Hex-file Folder:" $OUTPUT_FOLDER
  570. echo "$(tput sgr0)"
  571. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  572. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  573. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  574. else
  575. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  576. read -t 10 -p "Press Enter to continue..."
  577. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  578. fi
  579. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  580. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  581. # set FW_REPOSITORY
  582. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  583. #Prepare english only or multilanguage version to be build
  584. if [ $LANGUAGES == "ALL" ]; then
  585. echo " "
  586. echo "Multi-language firmware will be built"
  587. echo " "
  588. else
  589. echo " "
  590. echo "English only language firmware will be built"
  591. echo " "
  592. fi
  593. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  594. # if [ $TARGET_OS == "windows" ]; then
  595. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  596. # fi
  597. #### End of Prepare building
  598. #### Start building
  599. export ARDUINO=$BUILD_ENV_PATH
  600. #echo $BUILD_ENV_PATH
  601. #export BUILDER=$ARDUINO/arduino-builder
  602. echo
  603. #read -t 5 -p "Press Enter..."
  604. echo
  605. echo "Start to build Prusa Firmware ..."
  606. echo "Using variant $VARIANT$(tput setaf 3)"
  607. sleep 2
  608. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  609. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  610. echo "$(tput sgr 0)"
  611. if [ $LANGUAGES == "ALL" ]; then
  612. echo "$(tput setaf 2)"
  613. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  614. echo "$(tput sgr 0)"
  615. sleep 2
  616. cd $SCRIPT_PATH/lang
  617. echo "$(tput setaf 3)"
  618. ./config.sh || exit 31
  619. echo "$(tput sgr 0)"
  620. # Check if previous languages and firmware build exist and if so clean them up
  621. if [ -f "lang_en.tmp" ]; then
  622. echo ""
  623. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  624. read -t 10 -p "Press Enter to continue..."
  625. echo "$(tput setaf 3)"
  626. ./lang-clean.sh
  627. echo "$(tput sgr 0)"
  628. fi
  629. if [ -f "progmem.out" ]; then
  630. echo ""
  631. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  632. read -t 10 -p "Press Enter to continue..."
  633. echo "$(tput setaf 3)"
  634. ./fw-clean.sh
  635. echo "$(tput sgr 0)"
  636. fi
  637. # build languages
  638. echo "$(tput setaf 3)"
  639. ./lang-build.sh || exit 32
  640. # Combine compiled firmware with languages
  641. ./fw-build.sh || exit 33
  642. echo "$(tput sgr 0)"
  643. # Check if the motherboard is an EINSY and if so only one hex file will generated
  644. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  645. # If the motherboard is an EINSY just copy one hexfile
  646. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  647. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  648. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  649. else
  650. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  651. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  652. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  653. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  654. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  655. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  656. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  657. if [ $TARGET_OS == "windows" ]; then
  658. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  659. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  660. elif [ $TARGET_OS == "linux" ]; then
  661. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  662. fi
  663. fi
  664. # Cleanup after build
  665. echo "$(tput setaf 3)"
  666. ./fw-clean.sh || exit 34
  667. ./lang-clean.sh || exit 35
  668. echo "$(tput sgr 0)"
  669. else
  670. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  671. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  672. fi
  673. # Cleanup Firmware
  674. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  675. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  676. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  677. echo $MULTI_LANGUAGE_CHECK
  678. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  679. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  680. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  681. sleep 5
  682. done
  683. # Switch to hex path and list build files
  684. cd $SCRIPT_PATH
  685. cd ..
  686. echo "$(tput setaf 2) "
  687. echo " "
  688. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  689. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  690. #### End building